# Interface HTMLDocument

All Superinterfaces:
  `Document, Node`

public interface HTMLDocument extends Document
An `HTMLDocument` is the root of the HTML hierarchy and holds the entire content. Besides providing access to the hierarchy, it also provides some convenience methods for accessing certain sets of information from the document.

The following properties have been deprecated in favor of the corresponding ones for the `BODY` element: alinkColor background bgColor fgColor linkColor vlinkColor In DOM Level 2, the method `getElementById` is inherited from the `Document` interface where it was moved.

See also the Document Object Model (DOM) Level 2 Specification.

Since:
  1.4, DOM Level 2

## Field Summary

### Fields declared in interface Node

`ATTRIBUTE_NODE, CDATA_SECTION_NODE, COMMENT_NODE, DOCUMENT_FRAGMENT_NODE, DOCUMENT_NODE, DOCUMENT_POSITION_CONTAINED_BY, DOCUMENT_POSITION_CONTAINS, DOCUMENT_POSITION_DISCONNECTED, DOCUMENT_POSITION_FOLLOWING, DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC, DOCUMENT_POSITION_PRECEDING, DOCUMENT_TYPE_NODE, ELEMENT_NODE, ENTITY_NODE, ENTITY_REFERENCE_NODE, NOTATION_NODE, PROCESSING_INSTRUCTION_NODE, TEXT_NODE`
Modifier and Type
Field
Description
`static final short`
`ATTRIBUTE_NODE`
The node is an `Attr`.
`static final short`
`CDATA_SECTION_NODE`
The node is a `CDATASection`.
`static final short`
`COMMENT_NODE`
The node is a `Comment`.
`static final short`
`DOCUMENT_FRAGMENT_NODE`
The node is a `DocumentFragment`.
`static final short`
`DOCUMENT_NODE`
The node is a `Document`.
`static final short`
`DOCUMENT_POSITION_CONTAINED_BY`
The node is contained by the reference node.
`static final short`
`DOCUMENT_POSITION_CONTAINS`
The node contains the reference node.
`static final short`
`DOCUMENT_POSITION_DISCONNECTED`
The two nodes are disconnected.
`static final short`
`DOCUMENT_POSITION_FOLLOWING`
The node follows the reference node.
`static final short`
`DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC`
The determination of preceding versus following is implementation-specific.
`static final short`
`DOCUMENT_POSITION_PRECEDING`
The second node precedes the reference node.
`static final short`
`DOCUMENT_TYPE_NODE`
The node is a `DocumentType`.
`static final short`
`ELEMENT_NODE`
The node is an `Element`.
`static final short`
`ENTITY_NODE`
The node is an `Entity`.
`static final short`
`ENTITY_REFERENCE_NODE`
The node is an `EntityReference`.
`static final short`
`NOTATION_NODE`
The node is a `Notation`.
`static final short`
`PROCESSING_INSTRUCTION_NODE`
The node is a `ProcessingInstruction`.
`static final short`
`TEXT_NODE`
The node is a `Text` node.

## Method Summary

Modifier and Type
Method
Description
`void`
`close()`
Closes a document stream opened by `open()` and forces rendering.
`HTMLCollection`
`getAnchors()`
A collection of all the anchor (`A` ) elements in a document with a value for the `name` attribute.
`HTMLCollection`
`getApplets()`
A collection of all the `OBJECT` elements that include applets and `APPLET` ( deprecated ) elements in a document.
`HTMLElement`
`getBody()`
The element that contains the content for the document.
`String`
`getCookie()`
The cookies associated with this document.
`String`
`getDomain()`
The domain name of the server that served the document, or `null` if the server cannot be identified by a domain name.
`NodeList`
`getElementsByName(String elementName)`
Returns the (possibly empty) collection of elements whose `name` value is given by `elementName` .
`HTMLCollection`
`getForms()`
A collection of all the forms of a document.
`HTMLCollection`
`getImages()`
A collection of all the `IMG` elements in a document.
`HTMLCollection`
`getLinks()`
A collection of all `AREA` elements and anchor ( `A` ) elements in a document with a value for the `href` attribute.
`String`
`getReferrer()`
Returns the URI of the page that linked to this page.
`String`
`getTitle()`
The title of a document as specified by the `TITLE` element in the head of the document.
`String`
`getURL()`
The complete URI of the document.
`void`
`open()`
Note.
`void`
`setBody(HTMLElement body)`
`void`
`setCookie(String cookie)`
`void`
`setTitle(String title)`
`void`
`write(String text)`
Write a string of text to a document stream opened by `open()` .
`void`
`writeln(String text)`
Write a string of text followed by a newline character to a document stream opened by `open()` .

### Methods declared in interface Document

`adoptNode, createAttribute, createAttributeNS, createCDATASection, createComment, createDocumentFragment, createElement, createElementNS, createEntityReference, createProcessingInstruction, createTextNode, getDoctype, getDocumentElement, getDocumentURI, getDomConfig, getElementById, getElementsByTagName, getElementsByTagNameNS, getImplementation, getInputEncoding, getStrictErrorChecking, getXmlEncoding, getXmlStandalone, getXmlVersion, importNode, normalizeDocument, renameNode, setDocumentURI, setStrictErrorChecking, setXmlStandalone, setXmlVersion`
Modifier and Type
Method
Description
`Node`
`adoptNode(Node source)`
Attempts to adopt a node from another document to this document.
`Attr`
`createAttribute(String name)`
Creates an `Attr` of the given name.
`Attr`
`createAttributeNS(String namespaceURI, String qualifiedName)`
Creates an attribute of the given qualified name and namespace URI.
`CDATASection`
`createCDATASection(String data)`
Creates a `CDATASection` node whose value is the specified string.
`Comment`
`createComment(String data)`
Creates a `Comment` node given the specified string.
`DocumentFragment`
`createDocumentFragment()`
Creates an empty `DocumentFragment` object.
`Element`
`createElement(String tagName)`
Creates an element of the type specified.
`Element`
`createElementNS(String namespaceURI, String qualifiedName)`
Creates an element of the given qualified name and namespace URI.
`EntityReference`
`createEntityReference(String name)`
Creates an `EntityReference` object.
`ProcessingInstruction`
`createProcessingInstruction(String target, String data)`
Creates a `ProcessingInstruction` node given the specified name and data strings.
`Text`
`createTextNode(String data)`
Creates a `Text` node given the specified string.
`DocumentType`
`getDoctype()`
The Document Type Declaration (see `DocumentType`) associated with this document.
`Element`
`getDocumentElement()`
This is a convenience attribute that allows direct access to the child node that is the document element of the document.
`String`
`getDocumentURI()`
The location of the document or `null` if undefined or if the `Document` was created using `DOMImplementation.createDocument`.
`DOMConfiguration`
`getDomConfig()`
The configuration used when `Document.normalizeDocument()` is invoked.
`Element`
`getElementById(String elementId)`
Returns the `Element` that has an ID attribute with the given value.
`NodeList`
`getElementsByTagName(String tagname)`
Returns a `NodeList` of all the `Elements` in document order with a given tag name and are contained in the document.
`NodeList`
`getElementsByTagNameNS(String namespaceURI, String localName)`
Returns a `NodeList` of all the `Elements` with a given local name and namespace URI in document order.
`DOMImplementation`
`getImplementation()`
The `DOMImplementation` object that handles this document.
`String`
`getInputEncoding()`
An attribute specifying the encoding used for this document at the time of the parsing.
`boolean`
`getStrictErrorChecking()`
An attribute specifying whether error checking is enforced or not.
`String`
`getXmlEncoding()`
An attribute specifying, as part of the XML declaration, the encoding of this document.
`boolean`
`getXmlStandalone()`
An attribute specifying, as part of the XML declaration, whether this document is standalone.
`String`
`getXmlVersion()`
An attribute specifying, as part of the XML declaration, the version number of this document.
`Node`
`importNode(Node importedNode, boolean deep)`
Imports a node from another document to this document, without altering or removing the source node from the original document; this method creates a new copy of the source node.
`void`
`normalizeDocument()`
This method acts as if the document was going through a save and load cycle, putting the document in a "normal" form.
`Node`
`renameNode(Node n, String namespaceURI, String qualifiedName)`
Rename an existing node of type `ELEMENT_NODE` or `ATTRIBUTE_NODE`.
`void`
`setDocumentURI(String documentURI)`
The location of the document or `null` if undefined or if the `Document` was created using `DOMImplementation.createDocument`.
`void`
`setStrictErrorChecking(boolean strictErrorChecking)`
An attribute specifying whether error checking is enforced or not.
`void`
`setXmlStandalone(boolean xmlStandalone)`
An attribute specifying, as part of the XML declaration, whether this document is standalone.
`void`
`setXmlVersion(String xmlVersion)`
An attribute specifying, as part of the XML declaration, the version number of this document.

### Methods declared in interface Node

`appendChild, cloneNode, compareDocumentPosition, getAttributes, getBaseURI, getChildNodes, getFeature, getFirstChild, getLastChild, getLocalName, getNamespaceURI, getNextSibling, getNodeName, getNodeType, getNodeValue, getOwnerDocument, getParentNode, getPrefix, getPreviousSibling, getTextContent, getUserData, hasAttributes, hasChildNodes, insertBefore, isDefaultNamespace, isEqualNode, isSameNode, isSupported, lookupNamespaceURI, lookupPrefix, normalize, removeChild, replaceChild, setNodeValue, setPrefix, setTextContent, setUserData`
Modifier and Type
Method
Description
`Node`
`appendChild(Node newChild)`
Adds the node `newChild` to the end of the list of children of this node.
`Node`
`cloneNode(boolean deep)`
Returns a duplicate of this node, i.e., serves as a generic copy constructor for nodes.
`short`
`compareDocumentPosition(Node other)`
Compares the reference node, i.e. the node on which this method is being called, with a node, i.e. the one passed as a parameter, with regard to their position in the document and according to the document order.
`NamedNodeMap`
`getAttributes()`
A `NamedNodeMap` containing the attributes of this node (if it is an `Element`) or `null` otherwise.
`String`
`getBaseURI()`
The absolute base URI of this node or `null` if the implementation wasn't able to obtain an absolute URI.
`NodeList`
`getChildNodes()`
A `NodeList` that contains all children of this node.
`Object`
`getFeature(String feature, String version)`
This method returns a specialized object which implements the specialized APIs of the specified feature and version, as specified in .
`Node`
`getFirstChild()`
The first child of this node.
`Node`
`getLastChild()`
The last child of this node.
`String`
`getLocalName()`
Returns the local part of the qualified name of this node.
`String`
`getNamespaceURI()`
The namespace URI of this node, or `null` if it is unspecified (see ).
`Node`
`getNextSibling()`
The node immediately following this node.
`String`
`getNodeName()`
The name of this node, depending on its type; see the table above.
`short`
`getNodeType()`
A code representing the type of the underlying object, as defined above.
`String`
`getNodeValue()`
The value of this node, depending on its type; see the table above.
`Document`
`getOwnerDocument()`
The `Document` object associated with this node.
`Node`
`getParentNode()`
The parent of this node.
`String`
`getPrefix()`
The namespace prefix of this node, or `null` if it is unspecified.
`Node`
`getPreviousSibling()`
The node immediately preceding this node.
`String`
`getTextContent()`
This attribute returns the text content of this node and its descendants.
`Object`
`getUserData(String key)`
Retrieves the object associated to a key on a this node.
`boolean`
`hasAttributes()`
Returns whether this node (if it is an element) has any attributes.
`boolean`
`hasChildNodes()`
Returns whether this node has any children.
`Node`
`insertBefore(Node newChild, Node refChild)`
Inserts the node `newChild` before the existing child node `refChild`.
`boolean`
`isDefaultNamespace(String namespaceURI)`
This method checks if the specified `namespaceURI` is the default namespace or not.
`boolean`
`isEqualNode(Node arg)`
Tests whether two nodes are equal.
`boolean`
`isSameNode(Node other)`
Returns whether this node is the same node as the given one.
`boolean`
`isSupported(String feature, String version)`
Tests whether the DOM implementation implements a specific feature and that feature is supported by this node, as specified in .
`String`
`lookupNamespaceURI(String prefix)`
Look up the namespace URI associated to the given prefix, starting from this node.
`String`
`lookupPrefix(String namespaceURI)`
Look up the prefix associated to the given namespace URI, starting from this node.
`void`
`normalize()`
Puts all `Text` nodes in the full depth of the sub-tree underneath this `Node`, including attribute nodes, into a "normal" form where only structure (e.g., elements, comments, processing instructions, CDATA sections, and entity references) separates `Text` nodes, i.e., there are neither adjacent `Text` nodes nor empty `Text` nodes.
`Node`
`removeChild(Node oldChild)`
Removes the child node indicated by `oldChild` from the list of children, and returns it.
`Node`
`replaceChild(Node newChild, Node oldChild)`
Replaces the child node `oldChild` with `newChild` in the list of children, and returns the `oldChild` node.
`void`
`setNodeValue(String nodeValue)`
The value of this node, depending on its type; see the table above.
`void`
`setPrefix(String prefix)`
The namespace prefix of this node, or `null` if it is unspecified.
`void`
`setTextContent(String textContent)`
This attribute returns the text content of this node and its descendants.
`Object`
`setUserData(String key, Object data, UserDataHandler handler)`
Associate an object to a key on this node.

## Method Details

### getTitle

String getTitle()
The title of a document as specified by the `TITLE` element in the head of the document.

### setTitle

void setTitle(String title)

### getReferrer

String getReferrer()
Returns the URI of the page that linked to this page. The value is an empty string if the user navigated to the page directly (not through a link, but, for example, via a bookmark).

### getDomain

String getDomain()
The domain name of the server that served the document, or `null` if the server cannot be identified by a domain name.

### getURL

String getURL()
The complete URI of the document.

### getBody

HTMLElement getBody()
The element that contains the content for the document. In documents with `BODY` contents, returns the `BODY` element. In frameset documents, this returns the outermost `FRAMESET` element.

### setBody

void setBody(HTMLElement body)

### getImages

HTMLCollection getImages()
A collection of all the `IMG` elements in a document. The behavior is limited to `IMG` elements for backwards compatibility.

### getApplets

HTMLCollection getApplets()
A collection of all the `OBJECT` elements that include applets and `APPLET` ( deprecated ) elements in a document.

### getLinks

HTMLCollection getLinks()
A collection of all `AREA` elements and anchor ( `A` ) elements in a document with a value for the `href` attribute.

### getForms

HTMLCollection getForms()
A collection of all the forms of a document.

### getAnchors

HTMLCollection getAnchors()
A collection of all the anchor (`A` ) elements in a document with a value for the `name` attribute. Note. For reasons of backwards compatibility, the returned set of anchors only contains those anchors created with the `name` attribute, not those created with the `id` attribute.

### getCookie

String getCookie()
The cookies associated with this document. If there are none, the value is an empty string. Otherwise, the value is a string: a semicolon-delimited list of "name, value" pairs for all the cookies associated with the page. For example, `name=value;expires=date` .

### setCookie

void setCookie(String cookie)

### open

void open()
Note. This method and the ones following allow a user to add to or replace the structure model of a document using strings of unparsed HTML. At the time of writing alternate methods for providing similar functionality for both HTML and XML documents were being considered. The following methods may be deprecated at some point in the future in favor of a more general-purpose mechanism.
Open a document stream for writing. If a document exists in the target, this method clears it.

### close

void close()
Closes a document stream opened by `open()` and forces rendering.

### write

void write(String text)
Write a string of text to a document stream opened by `open()` . The text is parsed into the document's structure model.

Parameters:
  `text` - The string to be parsed into some structure in the document structure model.

### writeln

void writeln(String text)
Write a string of text followed by a newline character to a document stream opened by `open()` . The text is parsed into the document's structure model.

Parameters:
  `text` - The string to be parsed into some structure in the document structure model.

### getElementsByName

NodeList getElementsByName(String elementName)
Returns the (possibly empty) collection of elements whose `name` value is given by `elementName` .

Parameters:
  `elementName` - The `name` attribute value for an element.
Returns:
  The matching elements.